//<?php
/**
 * SolutionrDEVs Application
 * Rich Discord Integration
 *
 * @brief       Extends: \IPS\forums\Topic
 * @author      Dawid Baruch <dawid.baruch@solutiondevs.pl> <a href='https://www.solutiondevs.pl'>SolutionDEVs</a>
 * @copyright   (c) 2005 - 2019 SolutionDEVs
 * @package     SolutionDEVs Apps
 * @subpackage  Rich Discord Integration
 * @link        https://www.solutiondevs.pl
 * @link        https://www.ipsbeyond.pl
 * @since       06.02.2019
 * @version     1.0.11
 */

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
    exit;
}

class richdiscord_hook_forumsTopic extends _HOOK_CLASS_
{
    /**
     * Process created object AFTER the object has been created
     *
     * @param \IPS\Content\Comment|NULL $comment The first comment
     * @param array $values Values from form
     * @return void
     */
    protected function processAfterCreate( $comment, $values )
    {
	try
	{
	        if( \IPS\Settings::i()->richdiscord_sendnotification && trim( \IPS\Settings::i()->richdiscord_webhookurl ) != '' && ( \IPS\Settings::i()->richdiscord_forums == '0' || in_array( $this->container()->_id, explode( ',', \IPS\Settings::i()->richdiscord_forums ) ) ) )
	        {
	            $content = sprintf( \IPS\Member::loggedIn()->language()->get( 'richdiscord_topic_notification' ), $this->author()->name, $this->mapped( 'title' ), (string) $this->url() );
	
	            $payload = array(
	                'content'    => $content,
	                'tts'        => false,
	                'username'   => $this->author()->name,
	                'avatar_url' => (string) $this->author()->photo,
	                'embed'      => array(
	                    'title'       => $this->mapped( 'title' ),
	                    'description' => $content,
	                    'url'         => (string) $this->url(),
	                ),
	            );
	
	            try
	            {
	                $response = \IPS\Http\Url::external( \IPS\Settings::i()->richdiscord_webhookurl )
	                                         ->request()
	                                         ->post( json_encode( $payload ) );
	            }
	            catch( \Exception $e )
	            {
	            }
	        }
	
	        parent::processAfterCreate( $comment, $values );
	}
	catch ( \RuntimeException $e )
	{
		if ( method_exists( get_parent_class(), __FUNCTION__ ) )
		{
			return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
		}
		else
		{
			throw $e;
		}
	}
    }
}
