//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class richdiscord_hook_memberHook extends _HOOK_CLASS_
{
    public function richdiscordKick()
    {
	try
	{
		try
		{
		        if (!($this->richdiscord_id && \IPS\Application::load("richdiscord")->isConfigured())) {
		            return FALSE;
		        }
		        $id = $this->richdiscord_id;
		        $gid = \IPS\Settings::i()->richdiscord_guild;
		        try {
		            \IPS\richdiscord\Discord\Requestable::request("/guilds/$gid/members/$id", "DELETE");
		        } catch ( \IPS\richdiscord\Discord\Exceptions\BaseException $e ) {
		            return FALSE;
		        }
		        return TRUE;
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	catch ( \RuntimeException $e )
	{
		if ( method_exists( get_parent_class(), __FUNCTION__ ) )
		{
			return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
		}
		else
		{
			throw $e;
		}
	}
    }

    public function richdiscordBan()
    {
	try
	{
		try
		{
		        if (!($this->richdiscord_id && \IPS\Application::load("richdiscord")->isConfigured())) {
		            return FALSE;
		        }
		        $id = $this->richdiscord_id;
		        $gid = \IPS\Settings::i()->richdiscord_guild;
		        try {
		            \IPS\richdiscord\Discord\Requestable::request("/guilds/$gid/bans/$id?delete_message_days=0&reason=", "PUT");
		        } catch ( \IPS\richdiscord\Discord\Exceptions\BaseException $e ) {
		            return FALSE;
		        }
		        return TRUE;
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	catch ( \RuntimeException $e )
	{
		if ( method_exists( get_parent_class(), __FUNCTION__ ) )
		{
			return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
		}
		else
		{
			throw $e;
		}
	}
    }

    public function richdiscordSync( $approve=TRUE, $rolesManaged=[], $add=NULL )
    {
	try
	{
		try
		{
		        if (!($this->richdiscord_id && \IPS\Application::load("richdiscord")->isConfigured())) {
		            return FALSE;
		        }
		        $id = $this->richdiscord_id;
		        $gid = \IPS\Settings::i()->richdiscord_guild;
		        $rolesShouldHave = [];
		        $this->_groups = NULL;
		        $groups = $this->groups;
		        foreach ($groups as $ggid) {
		            $rolesShouldHave = array_merge($rolesShouldHave, \IPS\Member\Group::load($ggid)->g_richdiscord_roles);
		        }
		        $rolesShouldHave = array_filter(array_unique($rolesShouldHave), 'strlen');
		        if ($add !== NULL) {
		            if (count($rolesShouldHave) && !\IPS\Settings::i()->richdiscord_enable_queue) {
		                \IPS\richdiscord\Discord\Requestable::request("/guilds/$gid/members/$id", "PUT", json_encode([
		                    'nick' => $this->name,
		                    'roles' => $rolesShouldHave,
		                    'access_token' => $add
		                ]), 'application/json', NULL, [], TRUE);
		            } else {
		                \IPS\richdiscord\Discord\Requestable::request("/guilds/$gid/members/$id", "PUT", json_encode([
		                    'nick' => $this->name,
		                    'access_token' => $add
		                ]), 'application/json', NULL, [], TRUE);
		            }
		            return TRUE;
		        }
		        if ($this->isBanned()) {
		            $this->richdiscordKick();
		            return TRUE;
		        }
		        try {
		            $member = \IPS\richdiscord\Discord\Requestable::request("/guilds/$gid/members/$id")->decodeJson();
		        } catch (\IPS\richdiscord\Discord\Exceptions\BaseException $e ) {
		            return FALSE;
		        }
		        if (!count($rolesManaged)) {
		            foreach (\IPS\Member\Group::groups(TRUE, FALSE) as $k => $v) {
		                $rolesManaged = array_merge($rolesManaged, $v->g_richdiscord_roles);
		            }
		            $rolesManaged = array_unique($rolesManaged);
		        }
		        $rolesHaveNow = $member['roles'];
		        $rolesHaveManaged = array_filter($rolesHaveNow, function($val) use ($rolesManaged) {return in_array($val, $rolesManaged);});
		        if ((\IPS\Settings::i()->richdiscord_enable_queue && !count($rolesHaveManaged) && !$approve)) {
		            return TRUE;
		        }
		        $rolesToSet = array_filter(array_merge(array_values(array_diff($rolesHaveNow, $rolesHaveManaged)), $rolesShouldHave), 'strlen');
		        try {
		            \IPS\richdiscord\Discord\Requestable::request("/guilds/$gid/members/$id", "PATCH", json_encode([
		                'nick' => $this->name,
		                'roles' => $rolesToSet,
		            ]), 'application/json', NULL, [], TRUE);
		        } catch ( \IPS\richdiscord\Discord\Exceptions\ForbiddenException $e) {}
		        return TRUE;
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	catch ( \RuntimeException $e )
	{
		if ( method_exists( get_parent_class(), __FUNCTION__ ) )
		{
			return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
		}
		else
		{
			throw $e;
		}
	}
    }
}
