//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class richdiscord_hook_profileSettings extends _HOOK_CLASS_
{
    /**
     * New tab
     *
     * @return	string
     */
    protected function _discord()
    {
	try
	{
		try
		{
		        try
		        {
		            if ( !\IPS\Application::load( 'richdiscord' )->isConfigured() )
		            {
		                return NULL;
		            }
		            if ( \IPS\Request::i()->daction == 'unlink') {
		                if ( \IPS\Member::loggedIn()->richdiscord_id ) {
		                    \IPS\Member::loggedIn()->richdiscordKick();
		                    \IPS\Member::loggedIn()->richdiscord_id = NULL;
		                    \IPS\Member::loggedIn()->save();
		                    \IPS\Output::i()->redirect(\IPS\Http\Url::internal('app=core&module=system&controller=settings&area=discord'));
		                } else {
		                    $_SESSION['errmsgdiscord'] = 'richdiscord_account_not_linked';
		                    \IPS\Output::i()->redirect(\IPS\Http\Url::internal('app=core&module=system&controller=settings&area=discord'));
		                }
		            }
		            $url = \IPS\Http\Url::external("https://discordapp.com/api/v6/oauth2/authorize")->setQueryString( [
		                'response_type' => 'code',
		                'client_id' => \IPS\Settings::i()->richdiscord_client_id,
		                'scope' => 'identify guilds.join',
		                'redirect_uri' => \IPS\Settings::i()->base_url . 'applications/richdiscord/interface/oauth2/accounts.php'
		            ] );
		            $data = NULL;
		            if (\IPS\Member::loggedIn()->richdiscord_id) {
		                $id = \IPS\Member::loggedIn()->richdiscord_id;
		                try {
		                    $data = \IPS\richdiscord\Discord\Requestable::request( "/users/$id" )->decodeJson();
		                } catch ( \IPS\richdiscord\Discord\Exceptions\BaseException $e ) {
		                    \IPS\Log::log($e, 'discord_error');
		                }
		            }
		            $userdata = NULL;
		            if ($data) {
		                $userdata = [
		                    'name' => $data['username'],
		                    'discriminator' => $data['discriminator'],
		                    'avatar' => (string) ( $data['avatar'] ? \IPS\richdiscord\Discord\CDNObject::avatar( $data['id'], $data['avatar'], '.jpg') : \IPS\richdiscord\Discord\CDNObject::defaultAvatar( $data['discriminator'] ))->url()
		                ];
		            }
		            return \IPS\Theme::i()->getTemplate( "profile", "richdiscord", "front" )->discordSettings($userdata, $url);
		        }
		        catch ( \RuntimeException $e )
		        {
		            if ( method_exists( get_parent_class(), __FUNCTION__ ) )
		            {
		                return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
		            }
		            else
		            {
		                throw $e;
		            }
		        }
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	catch ( \RuntimeException $e )
	{
		if ( method_exists( get_parent_class(), __FUNCTION__ ) )
		{
			return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
		}
		else
		{
			throw $e;
		}
	}
    }
}
